## lcov 2.0

=== Makefile ===
#
# Makefile for LCOV
#
# Make targets:
#   - install:   install LCOV tools and man pages on the system
#   - uninstall: remove tools and man pages from the system
#   - dist:      create files required for distribution, i.e. the lcov.tar.gz
#                and the lcov.rpm file. Just make sure to adjust the VERSION
#                and RELEASE variables below - both version and date strings
#                will be updated in all necessary files.
#   - checkstyle: check source files for coding style issues
#                 MODE=(full|diff) [UPDATE=1]
#   - clean:     remove all generated files
#   - release:   finalize release and create git tag for specified VERSION
#   - test:      run regression tests.
#                additional Make variables:
#                  COVERGAGE=1
#                     - enable perl coverage data collection
#                  TESTCASE_ARGS=string
#                     - pass these arguments to testcase script
#                       Sample args:
#                          --update      - overwrite GOLD file with
#                                          result
#                          --parallel n  - use --parallel flag
#                          --home path   - path to lcov script
#                          --llvm        - use LLVM rather than gcc
#                         --keep-going  - don't stop on error
#                   Note that not all tests have been updated to use
#                   all flags

VERSION := $(shell bin/get_version.sh --version)
RELEASE := $(shell bin/get_version.sh --release)
FULL    := $(shell bin/get_version.sh --full)

# Set this variable during 'make install' to specify the interpreters used in
# installed scripts, or leave empty to keep the current interpreter.
export LCOV_PERL_PATH   := /usr/bin/perl
export LCOV_PYTHON_PATH := /usr/bin/python3

PREFIX  := /usr/local

CFG_DIR := $(PREFIX)/etc
BIN_DIR := $(PREFIX)/bin
LIB_DIR := $(PREFIX)/lib/lcov
MAN_DIR := $(PREFIX)/share/man
SCRIPT_DIR := $(PREFIX)/share/lcov/support-scripts
TMP_DIR := $(shell mktemp -d)
FILES   := $(wildcard bin/*) $(wildcard man/*) README Makefile \
	   $(wildcard rpm/*) lcovrc

EXES = lcov genhtml geninfo genpng gendesc
SCRIPTS = p4udiff p4annotate getp4version get_signature gitblame gitdiff \
	criteria analyzeInfoFiles spreadsheet.py py2lcov
LIBS = lcovutil.pm
MANPAGES = man1/lcov.1 man1/genhtml.1 man1/geninfo.1 man1/genpng.1 \
	man1/gendesc.1 man5/lcovrc.5

# Program for checking coding style
CHECKSTYLE = $(CURDIR)/bin/checkstyle.sh

INSTALL = install
FIX = $(realpath bin/fix.pl)
RM = rm

export V
ifeq ("${V}","1")
	echocmd=
else
	echocmd=echo $1 ;
.SILENT:
endif

.PHONY: all info clean install uninstall rpms test

all: info

info:
	@echo "Available make targets:"
	@echo "  install   : install binaries and man pages in DESTDIR (default /)"
	@echo "  uninstall : delete binaries and man pages from DESTDIR (default /)"
	@echo "  dist      : create packages (RPM, tarball) ready for distribution"
	@echo "  check     : perform self-tests"
	@echo "  checkstyle: check source files for coding style issues"
	@echo "  release   : finalize release and create git tag for specified VERSION"
	@echo "  test      : same as 'make check"

clean:
	$(call echocmd,"  CLEAN   lcov")
	rm -f lcov-*.tar.gz
	rm -f lcov-*.rpm
	$(MAKE) -C example -s clean
	$(MAKE) -C tests -s clean
	find . -name '*.tdy' -o -name '*.orig' | xargs rm -f

install:
	$(INSTALL) -d -m 755 $(DESTDIR)$(BIN_DIR)
	for b in $(EXES) ; do \
		$(call echocmd,"  INSTALL $(DESTDIR)$(BIN_DIR)/$$b") \
		$(INSTALL) -m 755 bin/$$b $(DESTDIR)$(BIN_DIR)/$$b ; \
		$(FIX) --version $(VERSION) --release $(RELEASE) \
		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
		       --fixinterp --fixver --fixlibdir --fixbindir \
		       --exec $(DESTDIR)$(BIN_DIR)/$$b ; \
	done
	$(INSTALL) -d -m 755 $(DESTDIR)$(SCRIPT_DIR)
	for s in $(SCRIPTS) ; do \
		$(call echocmd,"  INSTALL $(DESTDIR)$(SCRIPT_DIR)/$$s") \
		$(INSTALL) -m 755 bin/$$s $(DESTDIR)$(SCRIPT_DIR)/$$s ; \
		$(FIX) --version $(VERSION) --release $(RELEASE) \
		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
		       --fixinterp --fixver --fixlibdir --fixbindir \
		       --exec $(DESTDIR)$(SCRIPT_DIR)/$$s ; \
	done
	$(INSTALL) -d -m 755 $(DESTDIR)$(LIB_DIR)
	for l in $(LIBS) ; do \
		$(call echocmd,"  INSTALL $(DESTDIR)$(LIB_DIR)/$$l") \
		$(INSTALL) -m 644 lib/$$l $(DESTDIR)$(LIB_DIR)/$$l ; \
		$(FIX) --version $(VERSION) --release $(RELEASE) \
		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
		       --fixinterp --fixver --fixlibdir --fixbindir \
		       --exec $(DESTDIR)$(LIB_DIR)/$$l ; \
	done
	$(INSTALL) -d -m 755 $(DESTDIR)$(MAN_DIR)/man1
	$(INSTALL) -d -m 755 $(DESTDIR)$(MAN_DIR)/man5
	for m in $(MANPAGES) ; do \
		$(call echocmd,"  INSTALL $(DESTDIR)$(MAN_DIR)/$$m") \
		$(INSTALL) -m 644 man/`basename $$m` $(DESTDIR)$(MAN_DIR)/$$m ; \
		$(FIX) --version $(VERSION) --fixver --fixdate \
		       --fixscriptdir --scriptdir $(SCRIPT_DIR) \
		       --manpage $(DESTDIR)$(MAN_DIR)/$$m ; \
	done
	$(INSTALL) -d -m 755 $(DESTDIR)$(CFG_DIR)
	$(call echocmd,"  INSTALL $(DESTDIR)$(CFG_DIR)/lcovrc")
	$(INSTALL) -m 644 lcovrc $(DESTDIR)$(CFG_DIR)/lcovrc

uninstall:
	for b in $(EXES) ; do \
		$(call echocmd,"  UNINST  $(DESTDIR)$(BIN_DIR)/$$b") \
		$(RM) -f $(DESTDIR)$(BIN_DIR)/$$b ; \
	done
	for s in $(SCRIPTS) ; do \
		$(call echocmd,"  UNINST  $(DESTDIR)$(SCRIPT_DIR)/$$s")  \
		$(RM) -f $(DESTDIR)$(SCRIPT_DIR)/$$s ; \
	done
	for l in $(LIBS) ; do \
		$(call echocmd,"  UNINST  $(DESTDIR)$(LIB_DIR)/$$l") \
		$(RM) -f $(DESTDIR)$(LIB_DIR)/$$l ; \
	done
	for m in $(MANPAGES) ; do \
		$(call echocmd,"  UNINST  $(DESTDIR)$(MAN_DIR)/$$m") \
		$(RM) -f $(DESTDIR)$(MAN_DIR)/$$m ; \
	done
	$(call echocmd,"  UNINST  $(DESTDIR)$(CFG_DIR)/lcovrc")
	$(RM) -f $(DESTDIR)$(CFG_DIR)/lcovrc

dist: lcov-$(VERSION).tar.gz lcov-$(VERSION)-$(RELEASE).noarch.rpm \
      lcov-$(VERSION)-$(RELEASE).src.rpm

lcov-$(VERSION).tar.gz: $(FILES)
	$(call echocmd,"  DIST    lcov-$(VERSION).tar.gz")
	mkdir -p $(TMP_DIR)/lcov-$(VERSION)
	cp -r . $(TMP_DIR)/lcov-$(VERSION)
	rm -rf $(TMP_DIR)/lcov-$(VERSION)/.git
	bin/copy_dates.sh . $(TMP_DIR)/lcov-$(VERSION)
	$(MAKE) -s -C $(TMP_DIR)/lcov-$(VERSION) clean >/dev/null
	cd $(TMP_DIR)/lcov-$(VERSION) ; \
	$(FIX) --version $(VERSION) --release $(RELEASE) \
	       --verfile .version --fixver --fixdate \
	       $(patsubst %,bin/%,$(EXES)) $(patsubst %,bin/%,$(SCRIPTS)) \
	       $(patsubst %,lib/%,$(LIBS)) \
	       $(patsubst %,man/%,$(notdir $(MANPAGES))) README rpm/lcov.spec
	bin/get_changes.sh > $(TMP_DIR)/lcov-$(VERSION)/CHANGES
	cd $(TMP_DIR) ; \
	tar cfz $(TMP_DIR)/lcov-$(VERSION).tar.gz lcov-$(VERSION) \
	    --owner root --group root
	mv $(TMP_DIR)/lcov-$(VERSION).tar.gz .
	rm -rf $(TMP_DIR)

lcov-$(VERSION)-$(RELEASE).noarch.rpm: rpms
lcov-$(VERSION)-$(RELEASE).src.rpm: rpms

rpms: lcov-$(VERSION).tar.gz
	$(call echocmd,"  DIST    lcov-$(VERSION)-$(RELEASE).noarch.rpm")
	mkdir -p $(TMP_DIR)
	mkdir $(TMP_DIR)/BUILD
	mkdir $(TMP_DIR)/RPMS
	mkdir $(TMP_DIR)/SOURCES
	mkdir $(TMP_DIR)/SRPMS
	cp lcov-$(VERSION).tar.gz $(TMP_DIR)/SOURCES
	( \
	  cd $(TMP_DIR)/BUILD ; \
	  tar xfz ../SOURCES/lcov-$(VERSION).tar.gz \
		lcov-$(VERSION)/rpm/lcov.spec \
	)
	rpmbuild --define '_topdir $(TMP_DIR)' --define '_buildhost localhost' \
		 --undefine vendor --undefine packager \
		 -ba $(TMP_DIR)/BUILD/lcov-$(VERSION)/rpm/lcov.spec --quiet
	mv $(TMP_DIR)/RPMS/noarch/lcov-$(VERSION)-$(RELEASE).noarch.rpm .
	$(call echocmd,"  DIST    lcov-$(VERSION)-$(RELEASE).src.rpm")
	mv $(TMP_DIR)/SRPMS/lcov-$(VERSION)-$(RELEASE).src.rpm .
	rm -rf $(TMP_DIR)

ifeq ($(COVERAGE), 1)
# write to .../tests/cover_db
export COVER_DB := ./cover_db
endif
export TESTCASE_ARGS COVER_DB

test: check

check:
	if [ "x$(COVERAGE)" != 'x' ] && [ ! -d tests/$(COVER_DB) ]; then \
	  mkdir tests/$(COVER_DB) ; \
	fi
	@$(MAKE) -s -C tests check
	if [ "x$(COVERAGE)" != 'x' ] ; then \
	  ( cd tests ; cover ) ; \
	fi

# Files to be checked for coding style issue issues -
#   - anything containing "#!/usr/bin/env perl" or the like
#   - anything named *.pm - expected to be perl module
# ... as long as the name doesn't end in .tdy or .orig
checkstyle:
ifeq ($(MODE),full)
	@echo "Checking source files for coding style issues (MODE=full):"
else
	@echo "Checking changes in source files for coding style issues (MODE=diff):"
endif
	@RC=0 ;                                                  \
	CHECKFILES=`find . -path ./.git -prune -o \( \( -type f -exec grep -q '^#!.*perl' {} \; \) -o -name '*.pm' \) -not \( -name '*.tdy' -o -name '*.orig' -o -name '*~' \) -print `; \
	for FILE in $$CHECKFILES ; do                            \
	  $(CHECKSTYLE) "$$FILE";                                \
	  if [ 0 != $$? ] ; then                                 \
	    RC=1;                                                \
	    echo "saw mismatch for $$FILE";                      \
	    if [[ -f $$FILE.tdy && "$(UPDATE)x" != 'x' ]] ; then \
	      echo "updating $$FILE";                            \
	      mv $$FILE $$FILE.orig;                             \
	      mv $$FILE.tdy $$FILE ;                             \
            fi                                                   \
	  fi                                                     \
	done ;                                                   \
	exit $$RC

release:
	@if [ "$(origin VERSION)" != "command line" ] ; then echo "Please specify new version number, e.g. VERSION=1.16" >&2 ; exit 1 ; fi
	@if [ -n "$$(git status --porcelain 2>&1)" ] ; then echo "The repository contains uncommited changes" >&2 ; exit 1 ; fi
	@if [ -n "$$(git tag -l v$(VERSION))" ] ; then echo "A tag for the specified version already exists (v$(VERSION))" >&2 ; exit 1 ; fi
	@echo "Preparing release tag for version $(VERSION)"
	git checkout master
	bin/copy_dates.sh . .
	$(FIX) --version $(VERSION) --release $(RELEASE) \
	       --fixver --fixdate $(patsubst %,man/%,$(notdir $(MANPAGES))) \
	       README rpm/lcov.spec
	git commit -a -s -m "lcov: Finalize release $(VERSION)"
	git tag v$(VERSION) -m "LCOV version $(VERSION)"
	@echo "**********************************************"
	@echo "Release tag v$(VERSION) successfully created"
	@echo "Next steps:"
	@echo " - Review resulting commit and tag"
	@echo " - Publish with: git push origin master v$(VERSION)"
	@echo "**********************************************"

=== example/Makefile ===
#
# Makefile for the LCOV example program.
#
# Make targets:
#   - example: compile the example program
#   - output:  run test cases on example program and create HTML output
#   - clean:   clean up directory
#

CC      := gcc
CFLAGS  := -Wall -I. --coverage
LDFLAGS  := --coverage

LCOV    := ../bin/lcov
GENHTML := ../bin/genhtml
GENDESC := ../bin/gendesc
GENPNG  := ../bin/genpng

# Depending on the presence of the GD.pm perl module, we can use the
# special option '--frames' for genhtml
USE_GENPNG := $(shell $(GENPNG) --help >/dev/null 2>/dev/null; echo $$?)

ifeq ($(USE_GENPNG),0)
  FRAMES := --frames
else
  FRAMES :=
endif

ifeq ("${V}","1")
	echocmd=
else
	echocmd=echo $1 ;
.SILENT: clean
endif


.PHONY: clean output test_noargs test_2_to_2000 test_overflow

all: output

example: example.o iterate.o gauss.o
	$(CC) example.o iterate.o gauss.o -o example $(LDFLAGS)

example.o: example.c iterate.h gauss.h
	$(CC) $(CFLAGS) -c example.c -o example.o

iterate.o: methods/iterate.c iterate.h
	$(CC) $(CFLAGS) -c methods/iterate.c -o iterate.o

gauss.o: methods/gauss.c gauss.h
	$(CC) $(CFLAGS) -c methods/gauss.c -o gauss.o

output: example descriptions test_noargs test_2_to_2000 test_overflow
	@echo
	@echo '*'
	@echo '* Generating HTML output'
	@echo '*'
	@echo
	$(GENHTML) trace_noargs.info trace_args.info trace_overflow.info \
		   --output-directory output --title "Basic example" \
		   --show-details --description-file descriptions $(FRAMES) \
		   --legend
	@echo
	@echo '*'
	@echo '* See '`pwd`/output/index.html
	@echo '*'
	@echo

descriptions: descriptions.txt
	$(GENDESC) descriptions.txt -o descriptions

all_tests: example test_noargs test_2_to_2000 test_overflow

test_noargs:
	@echo
	@echo '*'
	@echo '* Test case 1: running ./example without parameters'
	@echo '*'
	@echo
	$(LCOV) --zerocounters --directory .
	./example
	$(LCOV) --capture --directory . --output-file trace_noargs.info --test-name test_noargs --no-external

test_2_to_2000:
	@echo
	@echo '*'
	@echo '* Test case 2: running ./example 2 2000'
	@echo '*'
	@echo
	$(LCOV) --zerocounters --directory .
	./example 2 2000
	$(LCOV) --capture --directory . --output-file trace_args.info --test-name test_2_to_2000 --no-external

test_overflow:
	@echo
	@echo '*'
	@echo '* Test case 3: running ./example 0 100000 (causes an overflow)'
	@echo '*'
	@echo
	$(LCOV) --zerocounters --directory .
	./example 0 100000 || true
	$(LCOV) --capture --directory . --output-file trace_overflow.info --test-name "test_overflow" --no-external

clean:
	$(call echocmd,"  CLEAN   lcov/example")
	rm -rf *.o *.bb *.bbg *.da *.gcno *.gcda *.info output example \
	descriptions

=== tests/Makefile ===
include common.mak

TESTS := genhtml/ lcov/ gendiffcov/ py2lcov

clean:
	rm -rf *.info *.counts test.log src/ ./cover_db

=== tests/gendiffcov/Makefile ===
include ../common.mak

TESTS := simple filter function insensitive

=== tests/genhtml/Makefile ===
include ../common.mak

TESTS := full.sh part1.sh part2.sh target.sh zero.sh demangle.sh

clean:
	rm -rf *.log out_* *.tmp

=== tests/lcov/Makefile ===
include ../common.mak

TESTS := add/ diff/ misc/ summary/ extract/ demangle/ exception/ gcov-tool/

=== tests/py2lcov/Makefile ===
include ../common.mak

TESTS : py2lcov.sh

clean:
	$(shell ./py2lcov.sh --clean)

=== tests/gendiffcov/filter/Makefile ===
include ../../common.mak

TESTS := filter.pl

clean:
	rm -f *.orig *.filtered

=== tests/gendiffcov/insensitive/Makefile ===
include ../../common.mak

TESTS := insensitive.sh

clean:
	$(shell ./insensitive.sh --clean)

=== tests/lcov/add/Makefile ===
include ../../common.mak

TESTS := zero.sh zero2.sh full.sh full2.sh part.sh part2.sh concatenated4.sh prune.sh track.sh

clean:
	rm -f *.info prune prune2 prune3 track

=== tests/lcov/exception/Makefile ===
include ../../common.mak

TESTS := exception.sh

clean:
	$(shell ./exception.sh --clean)

=== tests/lcov/diff/old/Makefile ===
prog.info:

include ../../../common.mak

prog.info: prog.gcda
	$(LCOV) -c -d `pwd` -o prog.info

prog.gcda: prog
	./prog || true

prog: prog.c
	$(CC) prog.c -o prog --coverage

clean:
	rm -f prog prog.gcda prog.gcno prog.info

.PHONY: all clean

=== debian/changelog ===
lcov (2.0-4ubuntu2) noble; urgency=medium

  * Add missing runtime dependency on libtimedate-perl (LP: #2058956)

 -- Dave Jones <dave.jones@canonical.com>  Mon, 25 Mar 2024 16:44:44 +0000

lcov (2.0-4ubuntu1) noble; urgency=medium

  * Re-enable tests by disabling multiple threads while building. Tests are
  * failing with multiple threads. (LP: #2052836)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 09 Feb 2024 20:28:32 +0000

lcov (2.0-4) unstable; urgency=medium

  * Missing runtime dependency on libdatetime-perl and libcapture-tiny-perl.
    Thanks  Diego Escalante Urrelo. Closes: #1053252
  * Mark lcov as Multi-arch: Foreign. Closes: #1040402

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 06 Jan 2024 12:23:45 +0000

lcov (2.0-3) unstable; urgency=medium

  * Bypass tests: currently they hang build 

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Sep 2023 15:56:37 +0100

lcov (2.0-2) unstable; urgency=medium

  * Ship lcovutil.pm in /usr/share/perl5. Closes: #1043009
  * Close bug fixed in lcov 1.16. Closes: #1035394
  * Patches obsolete/removed:
    - gcc8.patch
    - gcc-9-support.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 05 Sep 2023 13:17:44 +0100

lcov (2.0-1) unstable; urgency=medium

  * New upstream release
  * Patches now obsolete/merged:
    - handle-equals-signs.patch
    - fix-undef-behaviour.patch
    - reproducibility2.patch
    - 0001-bin-updateversion.pl-avoid-setting-timestamp-bui.patch
  * Fix by Vagrant Cascadian of embedded tz in timestamps breaking
    reproucibility. Closes: #10354394
  * Standards-Version: 4.6.2
  * Build-Dep on libdatetime-perl, libcapture-tiny-perl

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Aug 2023 16:19:48 +0100

=== debian/control ===
Source: lcov
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
  libjson-perl, 
  libperlio-gzip-perl, 
  libcapture-tiny-perl,
  libdatetime-perl,
  libtimedate-perl
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Homepage: https://github.com/linux-test-project/lcov.git
Vcs-Browser: https://salsa.debian.org:/mckinstry/lcov.git
Vcs-Git: https://salsa.debian.org:/mckinstry/lcov.git -b debian/latest
Standards-Version: 4.6.2

Package: lcov
Architecture: all
Depends:
  ${misc:Depends},
  ${perl:Depends},
  gcc,
  libcapture-tiny-perl,
  libdatetime-perl,
  libtimedate-perl,
  libjson-perl,
  libperlio-gzip-perl
Recommends: libgd-gd2-perl
Multi-Arch: foreign
Section: devel
Priority: optional
Description: Summarise Code coverage information from GCOV
 LCOV is an extension of GCOV, a GNU tool which provides information about
 what parts of a program are actually executed (i.e. "covered") while running
 a particular test case. The extension consists of a set of Perl scripts
 which build on the textual GCOV output to implement the following enhanced
 functionality:
 . 	                                                                                
  - HTML based output: coverage rates are additionally indicated using bar
    graphs and specific colors.
  - Support for large projects: overview pages allow quick browsing of
    coverage data by providing three levels of detail: directory view,
    file view and source code view.

=== debian/rules ===
#!/usr/bin/make -f

# Debhelper rules

export DH_VERBOSE=1

LC_ALL=C
export LC_ALL

%:
	dh $@ --no-parallel

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr
	rm -rf  debian/lcov/usr/etc

## lcov 2.1~beta2

=== Makefile ===
#
# Makefile for LCOV
#
# Make targets:
#   - install:   install LCOV tools and man pages on the system
#   - uninstall: remove tools and man pages from the system
#   - dist:      create files required for distribution, i.e. the lcov.tar.gz
#                and the lcov.rpm file. Just make sure to adjust the VERSION
#                and RELEASE variables below - both version and date strings
#                will be updated in all necessary files.
#   - checkstyle: check source files for coding style issues
#                 MODE=(full|diff) [UPDATE=1]
#   - clean:     remove all generated files
#   - release:   finalize release and create git tag for specified VERSION
#   - test:      run regression tests.
#                additional Make variables:
#                  COVERGAGE=1
#                     - enable perl coverage data collection
#                  TESTCASE_ARGS=string
#                     - pass these arguments to testcase script
#                       Sample args:
#                          --update      - overwrite GOLD file with
#                                          result
#                          --parallel n  - use --parallel flag
#                          --home path   - path to lcov script
#                          --llvm        - use LLVM rather than gcc
#                         --keep-going   - don't stop on error
#                         --verbose      - echo commands to test.log
#                   Note that not all tests have been updated to use
#                   all flags

VERSION := $(shell bin/get_version.sh --version)
RELEASE := $(shell bin/get_version.sh --release)
FULL    := $(shell bin/get_version.sh --full)

# Set this variable during 'make install' to specify the interpreters used in
# installed scripts, or leave empty to keep the current interpreter.
export LCOV_PERL_PATH   := /usr/bin/perl
export LCOV_PYTHON_PATH := /usr/bin/python3

PREFIX  := /usr/local

FIRST_CHAR = $(shell echo "$(DESTDIR)$(PREFIX)" | cut -c 1)
ifneq ("$(FIRST_CHAR)", "/")
$(error "DESTDIR + PREFIX expected to be absolute path - found $(FIRST_CHAR)")
endif

CFG_DIR := $(PREFIX)/etc
BIN_DIR := $(PREFIX)/bin
LIB_DIR := $(PREFIX)/lib/lcov
MAN_DIR := $(PREFIX)/share/man
SHARE_DIR := $(PREFIX)/share/lcov/
SCRIPT_DIR := $(SHARE_DIR)/support-scripts

CFG_INST_DIR := $(DESTDIR)$(CFG_DIR)
BIN_INST_DIR := $(DESTDIR)$(BIN_DIR)
LIB_INST_DIR := $(DESTDIR)$(LIB_DIR)
MAN_INST_DIR := $(DESTDIR)$(MAN_DIR)
SHARE_INST_DIR := $(DESTDIR)$(SHARE_DIR)
SCRIPT_INST_DIR := $(SHARE_INST_DIR)/support-scripts

TMP_DIR := $(shell mktemp -d)
FILES   := README Makefile lcovrc \
	   $(wildcard bin/*) $(wildcard example/*) $(wildcard lib/*) \
	   $(wildcard man/*) $(wildcard rpm/*) $(wildcard scripts/*)
DIST_CONTENT := CONTRIBUTING COPYING README Makefile lcovrc \
	bin example lib man rpm scripts tests

EXES = lcov genhtml geninfo genpng gendesc perl2lcov py2lcov xml2lcov xml2lcovutil.py
# there may be both public and non-public user scripts - so lets not show
#   any of their names
SCRIPTS = $(shell ls scripts | grep -v -E '([\#\~]|\.orig|\.bak|\.BAK)' )
LIBS = lcovutil.pm
# similarly, lets not talk about man pages
MANPAGES = $(foreach m, $(shell cd man ; ls *.1), man1/$(m)) \
	$(foreach m, $(shell cd man ; ls *.5), man5/$(m))

# Program for checking coding style
CHECKSTYLE = $(CURDIR)/bin/checkstyle.sh

INSTALL = install
FIX = $(realpath bin/fix.pl)
RM = rm

export V
ifeq ("${V}","1")
	echocmd=
else
	echocmd=echo $1 ;
.SILENT:
endif

.PHONY: all info clean install uninstall rpms test

all: info

info:
	@echo "Available make targets:"
	@echo "  install   : install binaries and man pages in DESTDIR (default /)"
	@echo "  uninstall : delete binaries and man pages from DESTDIR (default /)"
	@echo "  dist      : create packages (RPM, tarball) ready for distribution"
	@echo "  check     : perform self-tests"
	@echo "  checkstyle: check source files for coding style issues"
	@echo "  release   : finalize release and create git tag for specified VERSION"
	@echo "  test      : same as 'make check'"

clean:
	$(call echocmd,"  CLEAN   lcov")
	$(RM) -f lcov-*.tar.gz lcov-*.rpm
	$(RM) -rf ./bin/__pycache__
	$(MAKE) -C example -s clean
	$(MAKE) -C tests -s clean
	find . -name '*.tdy' -o -name '*.orig' | xargs rm -f

install:
	$(INSTALL) -d -m 755 $(BIN_INST_DIR)
	for b in $(EXES) ; do \
		$(call echocmd,"  INSTALL $(BIN_INST_DIR)/$$b") \
		$(INSTALL) -m 755 bin/$$b $(BIN_INST_DIR)/$$b ; \
		$(FIX) --version $(VERSION) --release $(RELEASE) \
		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
		       --fixinterp --fixver --fixlibdir --fixbindir \
		       --exec $(BIN_INST_DIR)/$$b ; \
	done
	$(INSTALL) -d -m 755 $(SCRIPT_INST_DIR)
	for s in $(SCRIPTS) ; do \
		$(call echocmd,"  INSTALL $(SCRIPT_INST_DIR)/$$s") \
		$(INSTALL) -m 755 scripts/$$s $(SCRIPT_INST_DIR)/$$s ; \
		$(FIX) --version $(VERSION) --release $(RELEASE) \
		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
		       --fixinterp --fixver --fixlibdir \
		       --fixscriptdir --scriptdir $(SCRIPT_DIR) \
		       --exec $(SCRIPT_INST_DIR)/$$s ; \
	done
	$(INSTALL) -d -m 755 $(LIB_INST_DIR)
	for l in $(LIBS) ; do \
		$(call echocmd,"  INSTALL $(LIB_INST_DIR)/$$l") \
		$(INSTALL) -m 644 lib/$$l $(LIB_INST_DIR)/$$l ; \
		$(FIX) --version $(VERSION) --release $(RELEASE) \
		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
		       --fixinterp --fixver --fixlibdir --fixbindir \
		       --exec $(LIB_INST_DIR)/$$l ; \
	done
	for section in 1 5 ; do \
		DEST=$(MAN_INST_DIR)/man$$section ; \
		$(INSTALL) -d -m 755 $$DEST ; \
		for m in man/*.$$section ; do  \
			F=`basename $$m` ; \
			$(call echocmd,"  INSTALL $$DEST/$$F") \
			  $(INSTALL) -m 644 man/$$F $$DEST/$$F ; \
			$(FIX) --version $(VERSION) --fixver --fixdate \
		         --fixscriptdir --scriptdir $(SCRIPT_DIR) \
		         --manpage $$DEST/$$F ; \
		done ;  \
	done
	mkdir -p $(SHARE_INST_DIR)
	for d in example tests ; do \
		( cd $$d ; make clean ) ; \
		find $$d -type d -exec mkdir -p "$(SHARE_INST_DIR){}" \; ; \
		find $$d -type f -exec $(INSTALL) -Dm 644 "{}" "$(SHARE_INST_DIR){}" \; ; \
	done ;
	@chmod -R ugo+x $(SHARE_INST_DIR)/tests/bin
	@find $(SHARE_INST_DIR)/tests \( -name '*.sh' -o -name '*.pl' \) -exec chmod ugo+x {} \;
	$(INSTALL) -d -m 755 $(CFG_INST_DIR)
	$(call echocmd,"  INSTALL $(CFG_INST_DIR)/lcovrc")
	$(INSTALL) -m 644 lcovrc $(CFG_INST_DIR)/lcovrc
	$(call echocmd,"  done INSTALL")


uninstall:
	for b in $(EXES) ; do \
		$(call echocmd,"  UNINST  $(BIN_INST_DIR)/$$b") \
		$(RM) -f $(BIN_INST_DIR)/$$b ; \
	done
	rmdir --ignore-fail-on-non-empty $(BIN_INST_DIR) || true
	for s in $(SCRIPTS) ; do \
		$(call echocmd,"  UNINST  $(SCRIPT_INST_DIR)/$$s")  \
		$(RM) -f $(SCRIPT_INST_DIR)/$$s ; \
	done
	rmdir --ignore-fail-on-non-empty $(SCRIPT_INST_DIR)
	for l in $(LIBS) ; do \
		$(call echocmd,"  UNINST  $(LIB_INST_DIR)/$$l") \
		$(RM) -f $(LIB_INST_DIR)/$$l ; \
	done
	rmdir --ignore-fail-on-non-empty $(LIB_INST_DIR) || true
	rmdir `dirname $(LIB_INST_DIR)` || true
	rm -rf `dirname $(SHARE_INST_DIR)`
	$(call echocmd,"  UNINST  $(CFG_INST_DIR)/lcovrc")
	$(RM) -f $(CFG_INST_DIR)/lcovrc
	rmdir --ignore-fail-on-non-empty $(CFG_INST_DIR) || true
	rmdir --ignore-fail-on-non-empty $(PREFIX)$(DESTDIR) || true

dist: lcov-$(VERSION).tar.gz lcov-$(VERSION)-$(RELEASE).noarch.rpm \
      lcov-$(VERSION)-$(RELEASE).src.rpm

lcov-$(VERSION).tar.gz: $(FILES)
	$(call echocmd,"  DIST    lcov-$(VERSION).tar.gz")
	$(RM) -rf $(TMP_DIR)/lcov-$(VERSION)
	mkdir -p $(TMP_DIR)/lcov-$(VERSION)
	cp -r $(DIST_CONTENT) $(TMP_DIR)/lcov-$(VERSION)
	./bin/copy_dates.sh . $(TMP_DIR)/lcov-$(VERSION)
	$(MAKE) -s -C $(TMP_DIR)/lcov-$(VERSION) clean >/dev/null
	cd $(TMP_DIR)/lcov-$(VERSION) ; \
	$(FIX) --version $(VERSION) --release $(RELEASE) \
	       --verfile .version --fixver --fixdate \
	       $(patsubst %,bin/%,$(EXES)) $(patsubst %,scripts/%,$(SCRIPTS)) \
	       $(patsubst %,lib/%,$(LIBS)) \
	       $(patsubst %,man/%,$(notdir $(MANPAGES))) README rpm/lcov.spec
	./bin/get_changes.sh > $(TMP_DIR)/lcov-$(VERSION)/CHANGES || true
	cd $(TMP_DIR) ; \
	tar cfz $(TMP_DIR)/lcov-$(VERSION).tar.gz lcov-$(VERSION) \
	    --owner root --group root
	mv $(TMP_DIR)/lcov-$(VERSION).tar.gz .
	rm -rf $(TMP_DIR)

lcov-$(VERSION)-$(RELEASE).noarch.rpm: rpms
lcov-$(VERSION)-$(RELEASE).src.rpm: rpms

rpms: lcov-$(VERSION).tar.gz
	$(call echocmd,"  DIST    lcov-$(VERSION)-$(RELEASE).noarch.rpm")
	mkdir -p $(TMP_DIR)
	mkdir $(TMP_DIR)/BUILD
	mkdir $(TMP_DIR)/RPMS
	mkdir $(TMP_DIR)/SOURCES
	mkdir $(TMP_DIR)/SRPMS
	cp lcov-$(VERSION).tar.gz $(TMP_DIR)/SOURCES
	( \
	  cd $(TMP_DIR)/BUILD ; \
	  tar xfz ../SOURCES/lcov-$(VERSION).tar.gz \
		lcov-$(VERSION)/rpm/lcov.spec \
	)
	rpmbuild --define '_topdir $(TMP_DIR)' --define '_buildhost localhost' \
		 --undefine vendor --undefine packager \
		 -ba $(TMP_DIR)/BUILD/lcov-$(VERSION)/rpm/lcov.spec --quiet
	mv $(TMP_DIR)/RPMS/noarch/lcov-$(VERSION)-$(RELEASE).noarch.rpm .
	$(call echocmd,"  DIST    lcov-$(VERSION)-$(RELEASE).src.rpm")
	mv $(TMP_DIR)/SRPMS/lcov-$(VERSION)-$(RELEASE).src.rpm .
	rm -rf $(TMP_DIR)

ifeq ($(COVERAGE), 1)
# write to .../tests/cover_db
export COVER_DB := $(shell echo `pwd`/tests/cover_db)
export PYCOV_DB := $(shell echo `pwd`/tests/pycov.dat)
export HTML_RPT := $(shell echo `pwd`/lcov_coverage)
#export LCOV_FORCE_PARALLEL = 1
endif
export TESTCASE_ARGS

test: check

# for COVERAGE mode check: run once with LCOV_FORCE_PARALLEL=1 and
#   once without - so we can merge the result
check:
	if [ "x$(COVERAGE)" != 'x' ] ; then                                 \
	  if [ ! -d $(COVER_DB) ]; then                                     \
	    mkdir $(COVER_DB) ;                                             \
	  fi ;                                                              \
	  echo "*** Run once, force parallel ***" ;                         \
	  LCOV_FORCE_PARALLEL=1 $(MAKE) -s -C tests check LCOV_HOME=`pwd` ; \
	  echo "*** Run again, no force ***" ;                              \
	fi
	@$(MAKE) -s -C tests check LCOV_HOME=`pwd`
	@if [ "x$(COVERAGE)" != 'x' ] ; then       \
	  $(MAKE) -s -C tests report ;             \
	fi

# Files to be checked for coding style issue issues -
#   - anything containing "#!/usr/bin/env perl" or the like
#   - anything named *.pm - expected to be perl module
# ... as long as the name doesn't end in .tdy or .orig
checkstyle:
ifeq ($(MODE),full)
	@echo "Checking source files for coding style issues (MODE=full):"
else
	@echo "Checking changes in source files for coding style issues (MODE=diff):"
endif
	@RC=0 ;                                                  \
	CHECKFILES=`find . -path ./.git -prune -o \( \( -type f -exec grep -q '^#!.*perl' {} \; \) -o -name '*.pm' \) -not \( -name '*.tdy' -o -name '*.orig' -o -name '*~' \) -print `; \
	for FILE in $$CHECKFILES ; do                            \
	  $(CHECKSTYLE) "$$FILE";                                \
	  if [ 0 != $$? ] ; then                                 \
	    RC=1;                                                \
	    echo "saw mismatch for $$FILE";                      \
	    if [ -f $$FILE.tdy -a "$(UPDATE)x" != 'x' ]; then    \
	      echo "updating $$FILE";                            \
	      mv $$FILE $$FILE.orig;                             \
	      mv $$FILE.tdy $$FILE ;                             \
	    fi                                                   \
	  fi                                                     \
	done ;                                                   \
	exit $$RC

release:
	@if [ "$(origin VERSION)" != "command line" ] ; then echo "Please specify new version number, e.g. VERSION=1.16" >&2 ; exit 1 ; fi
	@if [ -n "$$(git status --porcelain 2>&1)" ] ; then echo "The repository contains uncommitted changes" >&2 ; exit 1 ; fi
	@if [ -n "$$(git tag -l v$(VERSION))" ] ; then echo "A tag for the specified version already exists (v$(VERSION))" >&2 ; exit 1 ; fi
	@echo "Preparing release tag for version $(VERSION)"
	git checkout master

=== example/Makefile ===
--- 
+++ 
@@ -11,10 +11,26 @@
 CFLAGS  := -Wall -I. --coverage
 LDFLAGS  := --coverage
 
-LCOV    := ../bin/lcov
-GENHTML := ../bin/genhtml
-GENDESC := ../bin/gendesc
-GENPNG  := ../bin/genpng
+LCOV_FLAGS = --branch
+
+# path differs depending on whether we are in the install dir or not
+# run with "make LCOV_HOME=/path/to/my/release" if necessary
+
+ifeq ($(LCOV_HOME),)
+LCOV_HOME := $(shell if [ -d ../bin ] ; then echo `realpath ..` ; else echo `realpath ../../..` ; fi)
+endif
+
+EG_SRCDIR = $(shell if [ -d $(LCOV_HOME)/example ] ; then echo $(LCOV_HOME)/example ; else echo $(LCOV_HOME)/share/lcov/example ; fi)
+# override this variable to write the differential testcase data someplace
+#  else
+REPO = exampleRepo
+BINDIR = $(LCOV_HOME)/bin
+SCRIPTS = $(LCOV_HOME)/scripts
+LCOV    := $(BINDIR)/lcov $(LCOV_FLAGS)
+GENHTML := $(BINDIR)/genhtml $(LCOV_FLAGS)
+GENDESC := $(BINDIR)/gendesc
+GENPNG  := $(BINDIR)/genpng
+SCRIPTDIR = $(shell if [ -d ../scripts ] ; then echo $(SCRIPTS) ; else echo $(LCOV_HOME)/share/lcov/support-scripts ; fi)
 
 # Depending on the presence of the GD.pm perl module, we can use the
 # special option '--frames' for genhtml
@@ -34,12 +50,12 @@
 endif
 
 
-.PHONY: clean output test_noargs test_2_to_2000 test_overflow
+.PHONY: clean output test_noargs test_2_to_2000 test_overflow test_differential
 
 all: output
 
 example: example.o iterate.o gauss.o
-	$(CC) example.o iterate.o gauss.o -o example $(LDFLAGS)
+	$(CC) $^ -o $@ $(LDFLAGS)
 
 example.o: example.c iterate.h gauss.h
 	$(CC) $(CFLAGS) -c example.c -o example.o
@@ -50,7 +66,7 @@
 gauss.o: methods/gauss.c gauss.h
 	$(CC) $(CFLAGS) -c methods/gauss.c -o gauss.o
 
-output: example descriptions test_noargs test_2_to_2000 test_overflow
+output: example descriptions test_noargs test_2_to_2000 test_overflow test_differential
 	@echo
 	@echo '*'
 	@echo '* Generating HTML output'
@@ -65,11 +81,21 @@
 	@echo '* See '`pwd`/output/index.html
 	@echo '*'
 	@echo
+	@echo "Generate HTML with hierarchical report and additional navigation features"
+	@echo '*'
+	$(GENHTML) trace_noargs.info trace_args.info trace_overflow.info \
+		   --output-directory hierarchical \
+		   --title "Basic example - hierarchical" \
+		   --show-details --hierarchical --show-navigation \
+		   --description-file descriptions $(FRAMES) \
+		   --legend
+	@echo
+	@echo '* See '`pwd`/hierarchical/index.html
 
 descriptions: descriptions.txt
 	$(GENDESC) descriptions.txt -o descriptions
 
-all_tests: example test_noargs test_2_to_2000 test_overflow
+all_tests: example test_noargs test_2_to_2000 test_overflow differential
 
 test_noargs:
 	@echo
@@ -101,7 +127,88 @@
 	./example 0 100000 || true
 	$(LCOV) --capture --directory . --output-file trace_overflow.info --test-name "test_overflow" --no-external
 
+# This test pretends to write some code, run some tests, then modify
+#   code and rerun some tests.
+# The differential coverage report is categorizes the code based on
+#   what changed in the source code and what changed in the tests.
+# Note that we are suing perl module for callbacks here - but could use
+#   script or executable if desired.
+# Could use --verbose and --quiet flags to make the execution less noisy -
+#   but verbosity can help to debug configuration issues.
+# See the lcov README and man pages for more details.
+test_differential:
+	@echo
+	@echo '*'
+	@echo '* Test case 4: differential coverage example'
+	@echo '*'
+	@echo
+	@echo "Step 1: Initialize GIT repo with example source"
+	@$(RM) -rf $(REPO)
+	@git init $(REPO) ;
+	@(cd $(REPO) ; \
+	cp -f $(EG_SRCDIR)/*.h $(EG_SRCDIR)/example.c . ; \
+	mkdir methods ; cp -f $(EG_SRCDIR)/methods/{iterate,gauss}.c methods ; \
+	find . \( -name '*.h' -o -name '*.c' \) -exec git add {} \; ; \
+	git commit -m baseline ; git tag baseline )
+	@echo "Build example and run some tests"
+	(cd $(REPO) ; \
+	$(CC) -o example --coverage -I. example.c methods/gauss.c methods/iterate.c ; \
+	./example ; \
+	./example 2 1000 ; \
+	./example 2 100000 || true )
+
+	@echo "Step 2: Capture initial coverage"
+	(cd $(REPO) ; \
+	$(LCOV) --capture -o baseline.info -d . --version-script $(SCRIPTDIR)/gitversion.pm )
+
+	@echo "Step 3: Modify source code"
+	@(cd $(REPO) ; \
+	cp -f $(EG_SRCDIR)/example_mod.c example.c ; \
+	cp -f $(EG_SRCDIR)/methods/iterate_mod.c methods/iterate.c ; \
+	git add example.c methods/iterate.c ; git commit -m current ; \
+	git tag current )
+
+	@echo "Step 4: Rebuild and run tests (fewer tests this time)"
+	( cd $(REPO) ; \
+	find . -name '*.gc*' -delete ; \
+	$(CC) -o example --coverage -I. example.c methods/gauss.c methods/iterate.c ; \
+	./example )
+
+	@echo "Step 5: Capture new coverage (after source changes)"
+	(cd $(REPO) ; \
+	 $(LCOV) --capture -o current.info -d . --version-script $(SCRIPTDIR)/gitversion.pm )
+	@echo "Compute source diffs"
+	(cd $(REPO) ;                                       \
+	$(SCRIPTDIR)/gitdiff . `git rev-list -n 1 baseline` \
+	  `git rev-list -n 1 current` > udiff.txt )
+
+	@echo "Step 6: Generate differential coverage report"
+	(cd $(REPO) ;                                            \
+	$(GENHTML) -o differential --baseline-file baseline.info \
+	  --diff-file udiff.txt                                  \
+	  --title "Differential coverage example" --show-owners  \
+	  --annotate $(SCRIPTDIR)/gitblame.pm                    \
+	  --version-script $(SCRIPTDIR)/gitversion.pm            \
+	  -- current.info )
+
+	@echo "point your browser to `realpath $(REPO)`/differential/index.html"
+
+	@echo "Step 7: Generate subset report for code review:"
+	(cd $(REPO) ;                                            \
+	$(GENHTML) -o review --baseline-file baseline.info \
+	  --diff-file udiff.txt                                  \
+	  --title "Differential report for code review" --show-owners  \
+	  --annotate $(SCRIPTDIR)/gitblame.pm                    \
+	  --version-script $(SCRIPTDIR)/gitversion.pm            \
+	  --select-script $(SCRIPTDIR)/select.pm                 \
+	  --select-script --tla --select-script UNC,UIC,LBC      \
+	  -- current.info )
+
+	@echo "point your browser to `realpath $(REPO)`/review/index.html"
+
+
 clean:
 	$(call echocmd,"  CLEAN   lcov/example")
 	rm -rf *.o *.bb *.bbg *.da *.gcno *.gcda *.info output example \
-	descriptions
+	descriptions \
+	$(REPO) hierarchical

=== tests/Makefile ===
ifeq ($(COVERAGE), 1)
ifeq ($(COVER_DB),)
export COVER_DB := $(shell echo `pwd`/cover_db)
export PYCOV_DB := $(shell echo `pwd`/pycov.dat)
export HTML_RPT := $(shell echo `pwd`/lcov_coverage)
endif
endif

.PHONY: report

all: check report

include common.mak

TESTS := genhtml lcov gendiffcov py2lcov perl2lcov xml2lcov

# there may or may not be some .info files generated for exported
#  tools - py2lcov, perl2lcov, etc.  We want them included in the
#  report - but they might not have been generated, so we need to
#  ignore the potential 'empty glob pattern' error message and a
#  potential remote repo timestamp issue
report:
	$(SPREADSHEET_TOOL) -o report.xlsx `find . -name "*.json"`
	if [ "x$(COVERAGE)" != 'x' ] ; then \
	  cover $(COVER_DB) ; \
	  $(BINDIR)/perl2lcov -o perlcov.info $(COVER_DB) --version-script $(VERSION_SCRIPT) --exclude 'genError.pm' --exclude 'filter.pl' --omit-lines 'ERROR_INTERNAL' --omit-lines '\bdie\b' --ignore unsupported --filter region ; \
	  if [ -f $(PYCOV_DB) ] ; then \
	    $(BINDIR)/py2lcov -o pycov.info $(PYCOV_DB) --version-script $(VERSION_SCRIPT) ; \
	  fi ; \
	  $(BINDIR)/genhtml --parallel -o $(HTML_RPT) perlcov.info pycov.info --show-navigation --flat --branch --show-proportion --version-script $(VERSION_SCRIPT) --annotate-script $(ANNOTATE_SCRIPT) --ignore empty,inconsistent ; \
	  cp p*cov.info $(HTML_RPT) ; \
	  echo "Wrote HTML report to ${HTML_RPT}" ; \
	fi

clean:
	rm -rf *.info *.counts test.log src report.xlsx \
		$(COVER_DB) $(HTML_RPT) $(PYCOV_DB)

=== tests/genhtml/Makefile ===
include ../common.mak

TESTS := full.sh part1.sh part2.sh target.sh zero.sh demangle.sh relative lambda

clean:
	rm -rf *.log out_* *.tmp

=== tests/lcov/Makefile ===
include ../common.mak

TESTS := add/ diff/ misc/ summary/ extract/ demangle/ exception/ gcov-tool/ branch/ merge/ format errs

=== debian/changelog ===
lcov (2.1~beta2-1) unstable; urgency=medium

  * New upstream release
  * Depend on python:Depends

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 08 Apr 2024 16:22:38 +0100

lcov (2.1~beta-1) unstable; urgency=medium

  * New upstream release
  * Depend on libtimedate-perl, python. Closes: #1067687
  * Re-enable tests
  * Add B-D on libdevel-cover-perl

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 26 Mar 2024 07:07:09 +0000

lcov (2.0-5) UNRELEASED; urgency=medium

  * Disable multiple threads while building. Tests are failing
    with multiple threads.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 23 Jan 2024 21:27:37 +0000

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
   libperlio-gzip-perl, 
   libcapture-tiny-perl,
   libdatetime-perl,
-  libtimedate-perl
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+  libtimedate-perl,
+  libdevel-cover-perl
+Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Homepage: https://github.com/linux-test-project/lcov.git
 Vcs-Browser: https://salsa.debian.org:/mckinstry/lcov.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/lcov.git -b debian/latest
@@ -19,6 +19,7 @@
 Depends:
   ${misc:Depends},
   ${perl:Depends},
+  ${python3:Depends},
   gcc,
   libcapture-tiny-perl,
   libdatetime-perl,

=== debian/rules ===
--- 
+++ 
@@ -13,3 +13,6 @@
 override_dh_auto_install:
 	dh_auto_install -- PREFIX=/usr
 	rm -rf  debian/lcov/usr/etc
+
+# override_dh_auto_test:
+#	@echo Bypass tests - break build

## lcov 2.1

=== debian/changelog ===
lcov (2.1-1) unstable; urgency=medium

  * New upstream release
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required
  * Drop unnecessary field in d/control
  * Drop .git extensions on URLs as per lintian
  * Add B-D for dh-sequence-python3, helper
  * Fix paths on shell,perl scripts

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Sep 2024 17:56:04 +0100

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Section: devel
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+  dh-sequence-python3,
   libjson-perl, 
   libperlio-gzip-perl, 
   libcapture-tiny-perl,
@@ -9,14 +10,15 @@
   libtimedate-perl,
   libdevel-cover-perl
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Homepage: https://github.com/linux-test-project/lcov.git
-Vcs-Browser: https://salsa.debian.org:/mckinstry/lcov.git
-Vcs-Git: https://salsa.debian.org:/mckinstry/lcov.git -b debian/latest
-Standards-Version: 4.6.2
+Homepage: https://github.com/linux-test-project/lcov
+Vcs-Browser: https://salsa.debian.org/mckinstry/lcov
+Vcs-Git: https://salsa.debian.org/mckinstry/lcov.git -b debian/latest
+Standards-Version: 4.7.0
 
 Package: lcov
 Architecture: all
 Depends:
+  python3:any | python3-minimal:any,
   ${misc:Depends},
   ${perl:Depends},
   ${python3:Depends},
@@ -29,7 +31,6 @@
 Recommends: libgd-gd2-perl
 Multi-Arch: foreign
 Section: devel
-Priority: optional
 Description: Summarise Code coverage information from GCOV
  LCOV is an extension of GCOV, a GNU tool which provides information about
  what parts of a program are actually executed (i.e. "covered") while running

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 export LC_ALL
 
 %:
-	dh $@ --no-parallel
+	dh $@ --no-parallel --with python3
 
 override_dh_auto_install:
 	dh_auto_install -- PREFIX=/usr

## lcov 2.3

=== Makefile ===
--- 
+++ 
@@ -66,7 +66,10 @@
 DIST_CONTENT := CONTRIBUTING COPYING README Makefile lcovrc \
 	bin example lib man rpm scripts tests
 
-EXES = lcov genhtml geninfo genpng gendesc perl2lcov py2lcov xml2lcov xml2lcovutil.py
+EXES = \
+	lcov genhtml geninfo genpng gendesc \
+	perl2lcov py2lcov xml2lcov xml2lcovutil.py \
+	llvm2lcov
 # there may be both public and non-public user scripts - so lets not show
 #   any of their names
 SCRIPTS = $(shell ls scripts | grep -v -E '([\#\~]|\.orig|\.bak|\.BAK)' )
@@ -119,7 +122,7 @@
 		$(INSTALL) -m 755 bin/$$b $(BIN_INST_DIR)/$$b ; \
 		$(FIX) --version $(VERSION) --release $(RELEASE) \
 		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
-		       --fixinterp --fixver --fixlibdir --fixbindir \
+		       --fixver --fixlibdir --fixbindir \
 		       --exec $(BIN_INST_DIR)/$$b ; \
 	done
 	$(INSTALL) -d -m 755 $(SCRIPT_INST_DIR)
@@ -128,7 +131,7 @@
 		$(INSTALL) -m 755 scripts/$$s $(SCRIPT_INST_DIR)/$$s ; \
 		$(FIX) --version $(VERSION) --release $(RELEASE) \
 		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
-		       --fixinterp --fixver --fixlibdir \
+		       --fixver --fixlibdir \
 		       --fixscriptdir --scriptdir $(SCRIPT_DIR) \
 		       --exec $(SCRIPT_INST_DIR)/$$s ; \
 	done
@@ -138,7 +141,7 @@
 		$(INSTALL) -m 644 lib/$$l $(LIB_INST_DIR)/$$l ; \
 		$(FIX) --version $(VERSION) --release $(RELEASE) \
 		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
-		       --fixinterp --fixver --fixlibdir --fixbindir \
+		       --fixver --fixlibdir --fixbindir \
 		       --exec $(LIB_INST_DIR)/$$l ; \
 	done
 	for section in 1 5 ; do \
@@ -188,7 +191,7 @@
 	$(call echocmd,"  UNINST  $(CFG_INST_DIR)/lcovrc")
 	$(RM) -f $(CFG_INST_DIR)/lcovrc
 	rmdir --ignore-fail-on-non-empty $(CFG_INST_DIR) || true
-	rmdir --ignore-fail-on-non-empty $(PREFIX)$(DESTDIR) || true
+	rmdir --ignore-fail-on-non-empty $(DESTDIR)$(PREFIX) || true
 
 dist: lcov-$(VERSION).tar.gz lcov-$(VERSION)-$(RELEASE).noarch.rpm \
       lcov-$(VERSION)-$(RELEASE).src.rpm
@@ -230,6 +233,7 @@
 		lcov-$(VERSION)/rpm/lcov.spec \
 	)
 	rpmbuild --define '_topdir $(TMP_DIR)' --define '_buildhost localhost' \
+		 --define "_target_os linux" \
 		 --undefine vendor --undefine packager \
 		 -ba $(TMP_DIR)/BUILD/lcov-$(VERSION)/rpm/lcov.spec --quiet
 	mv $(TMP_DIR)/RPMS/noarch/lcov-$(VERSION)-$(RELEASE).noarch.rpm .
@@ -261,6 +265,7 @@
 	fi
 	@$(MAKE) -s -C tests check LCOV_HOME=`pwd`
 	@if [ "x$(COVERAGE)" != 'x' ] ; then       \
+	  $(MAKE) -s -C example LCOV_HOME=`pwd`;   \
 	  $(MAKE) -s -C tests report ;             \
 	fi
 
@@ -294,5 +299,3 @@
 	@if [ "$(origin VERSION)" != "command line" ] ; then echo "Please specify new version number, e.g. VERSION=1.16" >&2 ; exit 1 ; fi
 	@if [ -n "$$(git status --porcelain 2>&1)" ] ; then echo "The repository contains uncommitted changes" >&2 ; exit 1 ; fi
 	@if [ -n "$$(git tag -l v$(VERSION))" ] ; then echo "A tag for the specified version already exists (v$(VERSION))" >&2 ; exit 1 ; fi
-	@echo "Preparing release tag for version $(VERSION)"
-	git checkout master

=== debian/changelog ===
lcov (2.3-1) unstable; urgency=medium

  * New upstream release. Closes: #1093145
  * Close old bugs: Closes: #1085234
  * Re-enable tests, but capture, dont fail. Closes: #1064030

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 17 Jan 2025 07:50:08 +0000

lcov (2.1-2) unstable; urgency=medium

  * Relax dep to gcc| llvm. Thanks to Andrea Pappacoda. Closes: #1085234

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 17 Oct 2024 10:35:52 +0100

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
   ${misc:Depends},
   ${perl:Depends},
   ${python3:Depends},
-  gcc,
+  gcc | llvm,
   libcapture-tiny-perl,
   libdatetime-perl,
   libtimedate-perl,
